//****************************************************************************//
//                                                                            //
//                                TXYZPlot                                    //
//               A Borland C++ Builder 3D Plotting Component                  //
//               -------------------------------------------                  //
//               TXYZPlot is copyright 1998 Jeff Nicholson                    //
//                             jeffn@rt66.com                                 //
//                                                                            //
//   This software is provided "as is" without express or implied warranty.   //
//****************************************************************************//
#include <vcl\vcl.h>
#pragma hdrstop

#include <math.h>
#include <values.h>
#include "TXYZPlot.h"
//---------------------------------------------------------------------------//
//***************************************************************************//
//                          T3DPlotListMember                                //
//***************************************************************************//
//---------------------------------------------------------------------------//
T3DPlotListMember::T3DPlotListMember(TXYZPoint* z_in, int XPoints, int YPoints,
                           int PNumber, T3DPlotStyle PStyle,
                           TColor LColor, TColor SColor)
{
   int i;
   NumPoints = XPoints*YPoints;
   z = new TXYZPoint[NumPoints];
   for(i=0;i<NumPoints;i++)
      z[i] = z_in[i];
   NumXPoints = XPoints;
   NumYPoints = YPoints;
   PlotIndex = PNumber;
   LineColor = LColor;
   FillColor = SColor;
   PlotStyle = PStyle;
}
//---------------------------------------------------------------------------
__fastcall T3DPlotListMember::T3DPlotListMember(const T3DPlotListMember* PlotListMember)
{   // copy constructor
   int i;

   NumXPoints = PlotListMember->NumXPoints;
   NumYPoints = PlotListMember->NumYPoints;
   NumPoints = PlotListMember->NumPoints;
   z = new TXYZPoint[NumPoints];
   for(i=0;i<NumPoints;i++)
       z[i] = PlotListMember->z[i];
   FillColor = PlotListMember->FillColor;
   LineColor = PlotListMember->LineColor;
   PlotStyle = PlotListMember->PlotStyle;
   PlotIndex = PlotListMember->PlotIndex;
}
//---------------------------------------------------------------------------
bool T3DPlotListMember::AddPlot(TXYZPoint* z_in, int XPoints, int YPoints,
                           int PNumber, T3DPlotStyle PStyle,
                           TColor LColor, TColor SColor, TList* PlotList)
{
   bool PlotFound = false;
   int i;

   for(i=0;i<PlotList->Count;i++)
   {
      T3DPlotListMember *Ptr = (T3DPlotListMember *)PlotList->Items[i];
      if (Ptr->PlotIndex == PNumber)
      {
         PlotFound = true;
         PlotList->Delete(i);
         break;
      }
   }
   T3DPlotListMember* NewPtr = new T3DPlotListMember(z_in, XPoints, YPoints,
                           PNumber, PStyle, LColor, SColor);
   PlotList->Add(NewPtr);
   return PlotFound;
}
//---------------------------------------------------------------------------
bool T3DPlotListMember::RemovePlot(int PNumber, TList* PlotList)
{
   bool PlotFound;
   int i;

   for(i=0;i<PlotList->Count;i++)
   {
      T3DPlotListMember *Ptr = (T3DPlotListMember *)PlotList->Items[i];
      if (Ptr->PlotIndex == PNumber)
      {
         PlotFound = true;
         PlotList->Delete(i);
         break;
      }
   }

   return PlotFound;
}
//---------------------------------------------------------------------------//
//***************************************************************************//
//                            TXYZPoint                                      //
//***************************************************************************//
//---------------------------------------------------------------------------//
void TXYZPoint::RotateX(double Theta)
{
   double YY, ZZ;

   YY = cos(Theta)*Y + Z*sin(Theta);
   ZZ = cos(Theta)*Z - Y*sin(Theta);
   Y = YY;
   Z = ZZ;
}
//---------------------------------------------------------------------------
void TXYZPoint::RotateY(double Theta)
{
   double XX, ZZ;

   XX = cos(Theta)*X + Z*sin(Theta);
   ZZ = cos(Theta)*Z - X*sin(Theta);
   X = XX;
   Z = ZZ;
}
//---------------------------------------------------------------------------
void TXYZPoint::RotateZ(double Theta)
{
   double XX, YY;

   XX = cos(Theta)*X + Y*sin(Theta);
   YY = cos(Theta)*Y - X*sin(Theta);
   X = XX;
   Y = YY;
}
//---------------------------------------------------------------------------//
//***************************************************************************//
//                               TXYZPlot                                    //
//***************************************************************************//
//---------------------------------------------------------------------------//
static inline TXYZPlot *ValidCtrCheck()
{
	return new TXYZPlot(NULL);
}
//---------------------------------------------------------------------------
__fastcall TXYZPlot::TXYZPlot(TComponent* Owner)
	: TPaintBox(Owner)
{
   Origin = new TXYZPoint(0,0,0);
   PaintPage = new Graphics::TBitmap;
   XYZPlotList = new TList;
   FPointSize = 1;
   FXAxisColor = clRed;
   FYAxisColor = clGreen;
   FZAxisColor = clBlue;
   FBoxColor = clBlack;
   FPlaneColor = clYellow;
   FAutoScale = true;
   FFitToScreen = true;
   FXMax = 1;
   FYMax = 1;
   FZMax = 1;
   FXMin = 0;
   FYMin = 0;
   FZMin = 0;
   FTheta = 0;
   FPhi = 5.3;
   FPsi = 0.2;
   FMouseControl = true;
   FMouseFunction = mfRotate;
   FVanishingPoint = 100;
   FPerspectiveOn = true;
   FXLabelPrecision = 4;
   FYLabelPrecision = 4;
   FZLabelPrecision = 4;
   FYLabelFormat = AnsiString::sffGeneral;
   FXLabelFormat = AnsiString::sffGeneral;
   FZLabelFormat = AnsiString::sffGeneral;
   FShowXLabel = true;
   FShowYLabel = true;
   FShowZLabel = true;
   FShowOrigin = true;
   FAxisStyle = asBox;
   FAutoRedraw = true;
   Visible = true;
   DragXY = false;
   DragXZ = false;
   ZoomXY = false;
   ZoomXZ = false;
   RotatePhiPsi = false;
   RotatePhiTheta = false;
   MaxXValue = FXMax;
   MinXValue = FXMin;
   MaxYValue = FZMax;
   MinYValue = FZMin;
   Height = 150;
   Width = 200;
   Origin->SetPoint((FXMax+FXMin)/2,(FYMax+FYMin)/2,(FZMax+FZMin)/2);
}
//---------------------------------------------------------------------------
namespace Txyzplot
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TXYZPlot)};
		RegisterComponents("Additional", classes, 0);
	}
}
//---------------------------------------------------------------------------
__fastcall TXYZPlot::TXYZPlot(TXYZPlot& XYZPlot): TPaintBox(XYZPlot.Owner)
{
   XYZPlotList = new TList;
   PaintPage = new Graphics::TBitmap;
   Origin = new TXYZPoint(0,0,0);
   AssignPlot(&XYZPlot);
}
//---------------------------------------------------------------------------
__fastcall TXYZPlot::~TXYZPlot(void)
{
   XYZPlotList->Clear();
   XYZPlotList->Free();
   delete Origin;
   delete PaintPage;
}
//---------------------------------------------------------------------------
void TXYZPlot::AssignPlot(const TXYZPlot* XYZPlot)
{
   AssignPlotProperties(XYZPlot);
   AssignPlotData(XYZPlot);
}
//---------------------------------------------------------------------------
void TXYZPlot::AssignPlotData(const TXYZPlot* XYZPlot)
{
   int i;
   T3DPlotListMember* PlotPtr;

   XYZPlotList->Clear();
   for(i=0; i<XYZPlot->XYZPlotList->Count; i++)
   {
      T3DPlotListMember *Ptr = (T3DPlotListMember *)XYZPlot->XYZPlotList->Items[i];
      PlotPtr = new T3DPlotListMember(Ptr);
      XYZPlotList->Add(PlotPtr);
   }

   FindXYZMaxMin();
   ScaleScreen();
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void TXYZPlot::AppendPlotData(const TXYZPlot* XYZPlot)
{
   int i;
   T3DPlotListMember* PlotPtr;

   for(i=0; i<XYZPlot->XYZPlotList->Count; i++)
   {
      T3DPlotListMember *Ptr = (T3DPlotListMember *)XYZPlot->XYZPlotList->Items[i];
      PlotPtr = new T3DPlotListMember(Ptr);
      XYZPlotList->Add(PlotPtr);
   }

   FindXYZMaxMin();
   ScaleScreen();
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void TXYZPlot::AssignPlotProperties(const TXYZPlot* XYZPlot)
{
   FPointSize= XYZPlot->FPointSize;
   FXAxisColor=XYZPlot->FXAxisColor;
   FYAxisColor=XYZPlot->FYAxisColor;
   FZAxisColor=XYZPlot->FZAxisColor;
   FBoxColor=XYZPlot->FBoxColor;
   FPlaneColor=XYZPlot->FPlaneColor;
   FAutoScale=XYZPlot->FAutoScale;
   FFitToScreen=XYZPlot->FFitToScreen;
   FXMax =XYZPlot->FXMax;
   FYMax =XYZPlot->FYMax;
   FZMax =XYZPlot->FZMax;
   FXMin =XYZPlot->FXMin;
   FYMin =XYZPlot->FYMin;
   FZMin =XYZPlot->FZMin;
   FTheta =XYZPlot->FTheta;
   FPhi =XYZPlot->FPhi;
   FPsi =XYZPlot->FPsi;
   FMouseControl =XYZPlot->FMouseControl;
   FMouseFunction = XYZPlot->FMouseFunction;
   FVanishingPoint = XYZPlot->FVanishingPoint;
   FPerspectiveOn = XYZPlot->FPerspectiveOn;
   FXLabelPrecision = XYZPlot->FXLabelPrecision;
   FYLabelPrecision = XYZPlot->FYLabelPrecision;
   FZLabelPrecision = XYZPlot->FZLabelPrecision;
   FYLabelFormat =XYZPlot->FYLabelFormat;
   FXLabelFormat =XYZPlot->FXLabelFormat;
   FZLabelFormat =XYZPlot->FZLabelFormat;
   FShowXLabel = XYZPlot->FShowXLabel;
   FShowYLabel = XYZPlot->FShowYLabel;
   FShowZLabel = XYZPlot->FShowZLabel;
   FShowOrigin = XYZPlot->FShowOrigin;
   FAxisStyle = XYZPlot->FAxisStyle;
   FAutoRedraw = XYZPlot->FAutoRedraw;
   Visible = XYZPlot->Visible;
   MaxXValue = XYZPlot->MaxXValue;
   MinXValue = XYZPlot->MinXValue;
   MaxYValue = XYZPlot->MaxYValue;
   MinYValue = XYZPlot->MinYValue;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void TXYZPlot::CalculateAxisArray(void)
{
   AxisArray[0].SetPoint(FXMin,FYMin,FZMin);
   AxisArray[1].SetPoint(FXMax,FYMin,FZMin);
   AxisArray[2].SetPoint(FXMax,FYMax,FZMin);
   AxisArray[3].SetPoint(FXMin,FYMax,FZMin);
   AxisArray[4].SetPoint(FXMin,FYMin,FZMax);
   AxisArray[5].SetPoint(FXMax,FYMin,FZMax);
   AxisArray[6].SetPoint(FXMax,FYMax,FZMax);
   AxisArray[7].SetPoint(FXMin,FYMax,FZMax);
}
//---------------------------------------------------------------------------
bool TXYZPlot::XYZPlot(double z_array[], int NumXPoints, int NumYPoints,
                                  int PNumber, T3DPlotStyle PStyle,
                                  TColor LColor, TColor SColor)
{
   int i,j;
   bool PlotFound;

   TXYZPoint* data = new TXYZPoint[NumXPoints*NumYPoints];
   for(j=0;j<NumYPoints;j++)
      for(i=0;i<NumXPoints;i++)
         data[NumXPoints*j + i].SetPoint(i,j,z_array[NumXPoints*j + i]);

   T3DPlotListMember Member;
   PlotFound = Member.AddPlot(data, NumXPoints, NumYPoints, PNumber, PStyle,
                        LColor, SColor, XYZPlotList);

   delete[] data;
   FindXYZMaxMin();
   ScaleScreen();
   if(FAutoRedraw)
      Redraw();
   return(PlotFound);
}
//---------------------------------------------------------------------------
bool TXYZPlot::XYZPlot(double z_array[], int NumXPoints, int NumYPoints,
                                  double MinX, double MaxX, double MinY, double MaxY,
                                  int PNumber, T3DPlotStyle PStyle,
                                  TColor LColor, TColor SColor)
{
   int i,j;
   double dx=1, dy=1;
   bool PlotFound;

   TXYZPoint* data = new TXYZPoint[NumXPoints*NumYPoints];
   if (NumXPoints > 1)
      dx = (MaxX - MinX)/(NumXPoints-1);
   if (NumYPoints > 1)
      dy = (MaxY - MinY)/(NumYPoints - 1);

   for(j=0;j<NumYPoints;j++)
      for(i=0;i<NumXPoints;i++)
         data[NumXPoints*j + i].SetPoint(MinX+i*dx,MinY+j*dy,z_array[NumXPoints*j + i]);

   T3DPlotListMember Member;
   PlotFound = Member.AddPlot(data, NumXPoints, NumYPoints, PNumber, PStyle,
                        LColor, SColor, XYZPlotList);

   delete[] data;
   FindXYZMaxMin();
   ScaleScreen();
   if(FAutoRedraw)
      Redraw();
   return(PlotFound);
}
//---------------------------------------------------------------------------
bool TXYZPlot::XYZPlot(double z_array[][3], int NumPoints,
                                  int PNumber, T3DPlotStyle PStyle,
                                  TColor LColor, TColor SColor)
{
   int i,j;
   double dx, dy;
   bool PlotFound;

   TXYZPoint* data = new TXYZPoint[NumPoints];
   for(i=0;i<NumPoints;i++)
      data[i].SetPoint(z_array[i][0],z_array[i][1],z_array[i][2]);

   T3DPlotListMember Member;
   PlotFound = Member.AddPlot(data, NumPoints, 1, PNumber, PStyle,
                        LColor, SColor, XYZPlotList);

   delete[] data;
   FindXYZMaxMin();
   ScaleScreen();
   if(FAutoRedraw)
      Redraw();
   return(PlotFound);
}
//---------------------------------------------------------------------------
bool TXYZPlot::RemovePlot(int PNumber)
// deletes the plot with index PNumber.  If the plot exists, it is deleted, and
// a one is returned.  If a plot with index PNumber does not exist, a zero is returned
{
   bool PlotFound;
   T3DPlotListMember Member;
   PlotFound = Member.RemovePlot(PNumber, XYZPlotList);
   if(FAutoRedraw)
      Redraw();
   return(PlotFound);
}
//---------------------------------------------------------------------------
void TXYZPlot::FindXYZMaxMin(void)
{
   int i,j;
   T3DPlotListMember* CurrentPtr;

   if(FAutoScale)
   {
      if(XYZPlotList->Count == 0)
      {
         FXMin = 0;
         FXMax = 1;
         FYMin = 0;
         FYMax = 1;
         FZMin = 0;
         FZMax = 1;
      }
      else
      {
         FXMin = MAXDOUBLE;
         FXMax = -MAXDOUBLE;
         FYMin = MAXDOUBLE;
         FYMax = -MAXDOUBLE;
         FZMin = MAXDOUBLE;
         FZMax = -MAXDOUBLE;
      }
      for(j=0;j<XYZPlotList->Count;j++)
      {
         T3DPlotListMember *Ptr = (T3DPlotListMember *)XYZPlotList->Items[j];
         for(i=0;i<Ptr->NumPoints;i++)
         {
            if (Ptr->z[i].X < FXMin)
               FXMin = Ptr->z[i].X;
            if (Ptr->z[i].X > FXMax)
               FXMax = Ptr->z[i].X;
            if (Ptr->z[i].Y < FYMin)
               FYMin = Ptr->z[i].Y;
            if (Ptr->z[i].Y > FYMax)
               FYMax = Ptr->z[i].Y;
            if (Ptr->z[i].Z < FZMin)
               FZMin = Ptr->z[i].Z;
            if (Ptr->z[i].Z > FZMax)
               FZMax = Ptr->z[i].Z;
         }
      }
      if(FXMax==FXMin)
      {
         FXMax += 1;
         FXMin -= 1;
      }
      if(FYMax==FYMin)
      {
         FYMax += 1;
         FYMin -= 1;
      }
      if(FZMax==FZMin)
      {
         FZMax += 1;
         FZMin -= 1;
      }
      Origin->SetPoint((FXMax+FXMin)/2,(FYMax+FYMin)/2,(FZMax+FZMin)/2);
   }
}
//---------------------------------------------------------------------------
void TXYZPlot::ScaleScreen(void)
{
   int i;
   TXYPoint TwoDP;
   TXYZPoint ThreeDP;

   if(FFitToScreen)
   {
      CalculateAxisArray();
      TwoDP = (ConvertTo2D(&AxisArray[0]));
      MinXValue = TwoDP.X;
      MaxXValue = TwoDP.X;
      MinYValue = TwoDP.Y;
      MaxYValue = TwoDP.Y;
      for(i=1;i<8;i++)
      {
         TwoDP = (ConvertTo2D(&AxisArray[i]));
         if (TwoDP.X < MinXValue)
            MinXValue = TwoDP.X;
         if (TwoDP.X > MaxXValue)
            MaxXValue = TwoDP.X;
         if (TwoDP.Y < MinYValue)
            MinYValue = TwoDP.Y;
         if (TwoDP.Y > MaxYValue)
            MaxYValue = TwoDP.Y;
      }
   }
}
//---------------------------------------------------------------------------
inline TXYPoint TXYZPlot::LocalToScreen(TXYPoint P1)
{
  TXYPoint ScreenPoint;

  ScreenPoint.X = (ClientWidth-1)*(P1.X - MinXValue)/(MaxXValue-MinXValue);
  ScreenPoint.Y = (ClientHeight-1) - (ClientHeight-1)*(P1.Y - MinYValue)/(MaxYValue-MinYValue);

  return ScreenPoint;
}
//---------------------------------------------------------------------------
TXYZPoint TXYZPlot::LocalToGlobal(TXYZPoint P1)
{
   TXYZPoint ThreeDP;

   ThreeDP = P1;
   ThreeDP.X -= Origin->X;
   ThreeDP.Y -= Origin->Y;
   ThreeDP.Z -= Origin->Z;
   ThreeDP.RotateZ(FPhi);
   ThreeDP.RotateY(FTheta);
   ThreeDP.RotateX(FPsi);
   return ThreeDP;
}
//---------------------------------------------------------------------------
TXYPoint TXYZPlot::ConvertTo2D(TXYZPoint* P1)
{
   TXYPoint TwoDP;
   TXYZPoint ThreeDP;

   ThreeDP = *P1;
   ThreeDP = LocalToGlobal(ThreeDP);
   if ((ThreeDP.Z < VanishingPoint)&&(PerspectiveOn))
   {
      TwoDP.X = -ThreeDP.X * VanishingPoint/(VanishingPoint - ThreeDP.Y);
      TwoDP.Y = ThreeDP.Z * VanishingPoint/(VanishingPoint - ThreeDP.Y);
   }
   else if (PerspectiveOn)
   {
      TwoDP.X = 0;
      TwoDP.Y = 0;
   }
   else
   {
      TwoDP.X = -ThreeDP.X;
      TwoDP.Y = ThreeDP.Z;
   }
   return TwoDP;
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawXLabel(void)
{
   TXYPoint ScreenPoint;
   TXYZPoint XLabelPoint;
   AnsiString St;

   if(FShowXLabel)
   {
      PaintPage->Canvas->Font = Font;
      PaintPage->Canvas->Brush->Color = Color;
      XLabelPoint.SetPoint(FXMax-(FXMax-FXMin)/10,FYMin,FZMin+(FZMax-FZMin)/20);
      ScreenPoint = LocalToScreen(ConvertTo2D(&XLabelPoint));
      PaintPage->Canvas->TextOut(ScreenPoint.X,ScreenPoint.Y,
            St.FloatToStrF(double(FXMax),FXLabelFormat,FXLabelPrecision,FXLabelPrecision));
      XLabelPoint.SetPoint(FXMin+(FXMax-FXMin)/10,FYMin,FZMin+(FZMax-FZMin)/20);
      ScreenPoint = LocalToScreen(ConvertTo2D(&XLabelPoint));
      PaintPage->Canvas->TextOut(ScreenPoint.X,ScreenPoint.Y,
            St.FloatToStrF(double(FXMin),FXLabelFormat,FXLabelPrecision,FXLabelPrecision));
   }
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawYLabel(void)
{
   TXYPoint ScreenPoint;
   TXYZPoint YLabelPoint;
   AnsiString St;

   if(FShowYLabel)
   {
      PaintPage->Canvas->Font = Font;
      PaintPage->Canvas->Brush->Color = Color;
      YLabelPoint.SetPoint(FXMin,FYMax-(FYMax-FYMin)/10,FZMin+(FZMax-FZMin)/20);
      ScreenPoint = LocalToScreen(ConvertTo2D(&YLabelPoint));
      PaintPage->Canvas->TextOut(ScreenPoint.X,ScreenPoint.Y,
            St.FloatToStrF(double(FYMax),FYLabelFormat,FYLabelPrecision,FYLabelPrecision));
      YLabelPoint.SetPoint(FXMin,FYMin+(FYMax-FYMin)/10,FZMin+(FZMax-FZMin)/20);
      ScreenPoint = LocalToScreen(ConvertTo2D(&YLabelPoint));
      PaintPage->Canvas->TextOut(ScreenPoint.X,ScreenPoint.Y,
            St.FloatToStrF(double(FYMin),FYLabelFormat,FYLabelPrecision,FYLabelPrecision));
   }
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawZLabel(void)
{
   TXYPoint ScreenPoint;
   TXYZPoint ZLabelPoint;
   AnsiString St;

   if(FShowZLabel)
   {
      PaintPage->Canvas->Font = Font;
      PaintPage->Canvas->Brush->Color = Color;
      ZLabelPoint.SetPoint(FXMin,FYMin+(FYMax-FYMin)/20,FZMax);
      ScreenPoint = LocalToScreen(ConvertTo2D(&ZLabelPoint));
      PaintPage->Canvas->TextOut(ScreenPoint.X,ScreenPoint.Y,
            St.FloatToStrF(double(FZMax),FZLabelFormat,FZLabelPrecision,FZLabelPrecision));
      ZLabelPoint.SetPoint(FXMin,FYMin+(FYMax-FYMin)/20,FZMin+(FZMax-FZMin)/10);
      ScreenPoint = LocalToScreen(ConvertTo2D(&ZLabelPoint));
      PaintPage->Canvas->TextOut(ScreenPoint.X,ScreenPoint.Y,
            St.FloatToStrF(double(FZMin),FZLabelFormat,FZLabelPrecision,FZLabelPrecision));
   }
}
//---------------------------------------------------------------------------
inline void TXYZPlot::DrawXZPlane(void)
{
   TPoint* Points;
   int Plane1[5] = {0,1,5,4,0};

   Points = new TPoint[5];
   PaintPage->Canvas->Pen->Color = FBoxColor;
   CalculateAxisPlane(Points,0,Plane1);
   PaintPage->Canvas->Polyline(Points,4);
   delete[] Points;
}
//---------------------------------------------------------------------------
inline void TXYZPlot::DrawYZPlane(void)
{
   TPoint* Points;
   int Plane2[5] = {0,-1,3,4,0};

   Points = new TPoint[5];
   PaintPage->Canvas->Pen->Color = FBoxColor;
   CalculateAxisPlane(Points,0,Plane2);
   PaintPage->Canvas->Polyline(Points,4);
   delete[] Points;
}
//---------------------------------------------------------------------------
inline void TXYZPlot::DrawXYPlane(void)
{
   TPoint* Points;
   int Plane3[5] = {0,1,2,-1,0};

   Points = new TPoint[5];
   PaintPage->Canvas->Pen->Color = FBoxColor;
   CalculateAxisPlane(Points,0,Plane3);
   PaintPage->Canvas->Polyline(Points,4);
   delete[] Points;
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawXAxis(void)
{
   TXYPoint ScreenPoint;

   PaintPage->Canvas->Pen->Color = FXAxisColor;
   ScreenPoint = LocalToScreen(ConvertTo2D(&AxisArray[0]));
   PaintPage->Canvas->MoveTo(int(ScreenPoint.X), int(ScreenPoint.Y));
   ScreenPoint = LocalToScreen((ConvertTo2D(&AxisArray[1])));
   PaintPage->Canvas->LineTo(int(ScreenPoint.X), int(ScreenPoint.Y));
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawYAxis(void)
{
   TXYPoint ScreenPoint;

   PaintPage->Canvas->Pen->Color = FYAxisColor;
   ScreenPoint = LocalToScreen((ConvertTo2D(&AxisArray[0])));
   PaintPage->Canvas->MoveTo(int(ScreenPoint.X), int(ScreenPoint.Y));
   ScreenPoint = LocalToScreen((ConvertTo2D(&AxisArray[3])));
   PaintPage->Canvas->LineTo(int(ScreenPoint.X), int(ScreenPoint.Y));
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawZAxis(void)
{
   TXYPoint ScreenPoint;

   PaintPage->Canvas->Pen->Color = FZAxisColor;
   ScreenPoint = LocalToScreen((ConvertTo2D(&AxisArray[0])));
   PaintPage->Canvas->MoveTo(int(ScreenPoint.X), int(ScreenPoint.Y));
   ScreenPoint = LocalToScreen((ConvertTo2D(&AxisArray[4])));
   PaintPage->Canvas->LineTo(int(ScreenPoint.X), int(ScreenPoint.Y));
}
//---------------------------------------------------------------------------
int TXYZPlot::ConvertFarPoint(int Center, int Change)
{
   int i;

   if(Center<4)
   {
      if(Change<3)
      {
         i = Center + Change;
         if(i>3)
            i-=4;
         else if (i<0)
            i+=4;
      }
      else
      {
         i = Center + Change;
         if(i>7)
            i-=4;
         else if (i<4)
            i+=4;
      }
   }
   else
   {
      if(Change<3)
      {
         i = Center + Change;
         if(i>7)
            i-=4;
         else if (i<4)
            i+=4;
      }
      else
      {
         Change-=4;
         Center-=4;
         i = Center+Change;
         if(i>3)
            i-=4;
         else if (i<0)
            i+=4;
      }
   }
   return i;
}
//---------------------------------------------------------------------------
void TXYZPlot::CalculateAxisPlane(TPoint Points[5], int FP, int Change[5])
{
   int i,j;
   for(i=0;i<5;i++)
   {
      j = ConvertFarPoint(FP, Change[i]);
      Points[i].x = (LocalToScreen(ConvertTo2D(&AxisArray[j]))).X;
      Points[i].y = (LocalToScreen(ConvertTo2D(&AxisArray[j]))).Y;
   }
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawBackAxis(void)
{
   int i;
   TPoint* Points;
   int Plane1[5] = {0,1,5,4,0};
   int Plane2[5] = {0,-1,3,4,0};
   int Plane3[5] = {0,1,2,-1,0};

   Points = new TPoint[5];
   FarPoint = 0;
   for(i=0;i<8;i++)
      if ((LocalToGlobal(AxisArray[i])).Y <
           (LocalToGlobal(AxisArray[FarPoint])).Y)
         FarPoint = i;
   switch(FAxisStyle)
   {
      case asBox :
         PaintPage->Canvas->Pen->Color = FBoxColor;
         CalculateAxisPlane(Points,FarPoint,Plane1);
         PaintPage->Canvas->Polyline(Points,4);
         CalculateAxisPlane(Points,FarPoint,Plane2);
         PaintPage->Canvas->Polyline(Points,4);
         CalculateAxisPlane(Points,FarPoint,Plane3);
         PaintPage->Canvas->Polyline(Points,4);
         break;
      case asBoxAndPlane :
         PaintPage->Canvas->Pen->Color = FBoxColor;
         PaintPage->Canvas->Brush->Color = FPlaneColor;
         CalculateAxisPlane(Points,FarPoint,Plane1);
         PaintPage->Canvas->Polygon(Points,3);
         CalculateAxisPlane(Points,FarPoint,Plane2);
         PaintPage->Canvas->Polygon(Points,3);
         CalculateAxisPlane(Points,FarPoint,Plane3);
         PaintPage->Canvas->Polygon(Points,3);
         break;
      case asXYZPlane :
         switch(FarPoint)
         {
            case 0 : DrawXZPlane(); DrawYZPlane(); DrawXYPlane(); break;
            case 1 : DrawXYPlane(); DrawXZPlane(); break;
            case 2 : DrawXYPlane(); break;
            case 3 : DrawXYPlane(); DrawYZPlane(); break;
            case 4 : DrawXZPlane(); DrawYZPlane(); break;
            case 5 : DrawXZPlane(); break;
            case 7 : DrawYZPlane(); break;
         }
         break;
   }
   if(AxisStyle != asNone)
      switch(FarPoint)
         {
            case 0 : case 4 : DrawXAxis();DrawYAxis();DrawZAxis();break;
            case 3 : case 7 : DrawYAxis(); DrawZAxis(); break;
            case 1 : case 5 : DrawXAxis(); DrawZAxis(); break;
         }

   switch(FarPoint)
   {
      case 0 : case 4 : DrawXLabel();DrawYLabel();DrawZLabel();break;
      case 3 : case 7 : DrawYLabel(); DrawZLabel(); break;
      case 1 : case 5 : DrawXLabel(); DrawZLabel(); break;
   }
   delete[] Points;
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawFrontAxis(void)
{
   TPoint* Points;
   int Plane1[5] = {0,1,5,4,0};
   int Plane2[5] = {0,-1,3,4,0};
   int Plane3[5] = {0,1,2,-1,0};

   Points = new TPoint[5];

   PaintPage->Canvas->Pen->Color = FBoxColor;
   FarPoint = ConvertFarPoint(FarPoint,6);
   switch(FAxisStyle)
   {
      case asBox : case asBoxAndPlane :
         CalculateAxisPlane(Points,FarPoint,Plane1);
         PaintPage->Canvas->Polyline(Points,4);
         CalculateAxisPlane(Points,FarPoint,Plane2);
         PaintPage->Canvas->Polyline(Points,4);
         CalculateAxisPlane(Points,FarPoint,Plane3);
         PaintPage->Canvas->Polyline(Points,4);
         break;
      case asXYZPlane :
         switch(FarPoint)
         {
            case 0 : DrawXZPlane(); DrawYZPlane(); DrawXYPlane(); break;
            case 1 : DrawXYPlane(); DrawXZPlane(); break;
            case 2 : DrawXYPlane(); break;
            case 3 : DrawXYPlane(); DrawYZPlane(); break;
            case 4 : DrawXZPlane(); DrawYZPlane(); break;
            case 5 : DrawXZPlane(); break;
            case 7 : DrawYZPlane(); break;
         }
         break;
   }
   if(AxisStyle != asNone)
      switch(FarPoint)
         {
            case 0 : case 4 : DrawXAxis();DrawYAxis();DrawZAxis();break;
            case 3 : case 7 : DrawYAxis(); DrawZAxis(); break;
            case 1 : case 5 : DrawXAxis(); DrawZAxis(); break;
         }

   switch(FarPoint)
   {
      case 0 : case 4 : DrawXLabel();DrawYLabel();DrawZLabel();break;
      case 3 : case 7 : DrawYLabel(); DrawZLabel(); break;
      case 1 : case 5 : DrawXLabel(); DrawZLabel(); break;
   }
   delete[] Points;
}
//---------------------------------------------------------------------------
inline void TXYZPlot::DrawAxis(void)
{
   DrawXAxis();
   DrawYAxis();
   DrawZAxis();
}
//---------------------------------------------------------------------------
void TXYZPlot::ClearPlot(void)
{
  // Clear the plot for redrawing
  if(Visible)
  {
     PaintPage->Canvas->Brush->Style = bsSolid;
     PaintPage->Canvas->Brush->Color = Color;
     PaintPage->Canvas->FillRect(ClientRect);
  }
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawGrid(T3DPlotListMember* PlotPtr, int i, int j)
{
   TXYPoint TwoDP;
   double xx, yy, x2, y2;
   int NX, NY;

   NX = PlotPtr->NumXPoints;
   NY = PlotPtr->NumYPoints;
   TwoDP = ConvertTo2D(&(PlotPtr->z[NX*j+i]));
   xx = (LocalToScreen(TwoDP)).X;
   yy = (LocalToScreen(TwoDP)).Y;
   PaintPage->Canvas->MoveTo(xx,yy);
   if (j<(NY-1))
   {
      TwoDP = ConvertTo2D(&(PlotPtr->z[NX*(j+1) + i]));
      x2 = (LocalToScreen(TwoDP)).X;
      y2 = (LocalToScreen(TwoDP)).Y;
      PaintPage->Canvas->LineTo(x2,y2);
   }
   PaintPage->Canvas->MoveTo(xx,yy);
   if (i<(NX-1))
   {
      TwoDP = ConvertTo2D(&(PlotPtr->z[NX*j + i+1]));
      x2 = (LocalToScreen(TwoDP)).X;
      y2 = (LocalToScreen(TwoDP)).Y;
      PaintPage->Canvas->LineTo(x2,y2);
   }
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawPolygon(T3DPlotListMember* PlotPtr, int i, int j)
{
   TXYPoint TwoDP;
   TPoint* Points;
   int NX, NY;

   NX = PlotPtr->NumXPoints;
   NY = PlotPtr->NumYPoints;
   if((i<(NX-1))&&(j<(NY-1)))
   {
      Points = new TPoint[4];
      TwoDP = ConvertTo2D(&(PlotPtr->z[NX*j+i]));
      Points[0].x = (LocalToScreen(TwoDP)).X;
      Points[0].y = (LocalToScreen(TwoDP)).Y;
      TwoDP = ConvertTo2D(&(PlotPtr->z[NX*j + i+1]));
      Points[1].x  = (LocalToScreen(TwoDP)).X;
      Points[1].y  = (LocalToScreen(TwoDP)).Y;
      TwoDP = ConvertTo2D(&(PlotPtr->z[NX*(j+1) + i+1]));
      Points[2].x = (LocalToScreen(TwoDP)).X;
      Points[2].y = (LocalToScreen(TwoDP)).Y;
      TwoDP = ConvertTo2D(&(PlotPtr->z[NX*(j+1) + i]));
      Points[3].x  = (LocalToScreen(TwoDP)).X;
      Points[3].y  = (LocalToScreen(TwoDP)).Y;
      PaintPage->Canvas->Polygon(Points,3);
      delete[] Points;
   }
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawOnePlot(T3DPlotListMember* PlotPtr)
{
   int i,j,xx,yy,x2,y2;
   int ii,jj;
   TXYPoint TwoDP;
   int NY, NX, NP;

   if(Visible)
   {
      PaintPage->Canvas->Pen->Color = PlotPtr->LineColor;
      PaintPage->Canvas->Brush->Color = PlotPtr->FillColor;
      NX = PlotPtr->NumXPoints;
      NY = PlotPtr->NumYPoints;
      switch (PlotPtr->PlotStyle)
      {
         case psSurface :
            if(((DistantPoint==0)&&(DistantPoint2==1))||
               ((DistantPoint==1)&&(DistantPoint2==0))||
               ((DistantPoint==2)&&(DistantPoint2==3))||
               ((DistantPoint==3)&&(DistantPoint2==2)))
            {
               for(j=0;j<NY;j++)
                  for(i=0;i<NX;i++)
                  {
                     switch(DistantPoint)
                     {
                        case 0 : ii=i;
                                 jj=j;
                                 break;
                        case 1 : ii=NX-i-1;
                                 jj=j;
                                 break;
                        case 2 : ii=i;
                                 jj=NY-j-1;
                                 break;
                        case 3 : ii=NX-i-1;
                                 jj=NY-j-1;
                                 break;
                      }
                      DrawPolygon(PlotPtr,ii,jj);
                  }
            }
            else
            {
               for(i=0;i<NX;i++)
                  for(j=0;j<NY;j++)
                  {
                     switch(DistantPoint)
                     {
                        case 0 : ii=i;
                                 jj=j;
                                 break;
                        case 1 : ii=NX-i-1;
                                 jj=j;
                                 break;
                        case 2 : ii=i;
                                 jj=NY-j-1;
                                 break;
                        case 3 : ii=NX-i-1;
                                 jj=NY-j-1;
                                 break;
                     }
                     DrawPolygon(PlotPtr,ii,jj);
                  }
            }
            break;
         case psGrid :
            for(j=0;j<NY;j++)
               for(i=0;i<NX;i++)
               {
                  DrawGrid(PlotPtr,i,j);
               }
            break;
         case psLines :
            TwoDP = ConvertTo2D(&(PlotPtr->z[0]));
            xx = (LocalToScreen(TwoDP)).X;
            yy = (LocalToScreen(TwoDP)).Y;
            PaintPage->Canvas->MoveTo(xx,yy);
            for(i=1;i<NX*NY;i++)
            {
               TwoDP = ConvertTo2D(&(PlotPtr->z[i]));
               xx = (LocalToScreen(TwoDP)).X;
               yy = (LocalToScreen(TwoDP)).Y;
               PaintPage->Canvas->LineTo(xx,yy);
             }
             break;
         case psPoints :
            for(i=0;i<NX*NY;i++)
            {
               TwoDP = ConvertTo2D(&(PlotPtr->z[i]));
               xx = (LocalToScreen(TwoDP)).X;
               yy = (LocalToScreen(TwoDP)).Y;
               PaintPage->Canvas->Rectangle(xx-FPointSize,yy-FPointSize,xx+FPointSize,yy+FPointSize);
            }
            break;
         case psLinesPoints :
            TwoDP = ConvertTo2D(&(PlotPtr->z[0]));
            xx = (LocalToScreen(TwoDP)).X;
            yy = (LocalToScreen(TwoDP)).Y;
            PaintPage->Canvas->Rectangle(xx-FPointSize,yy-FPointSize,xx+FPointSize,yy+FPointSize);
            PaintPage->Canvas->MoveTo(xx,yy);
            for(i=1;i<NX*NY;i++)
            {
               TwoDP = ConvertTo2D(&(PlotPtr->z[i]));
               xx = (LocalToScreen(TwoDP)).X;
               yy = (LocalToScreen(TwoDP)).Y;
               PaintPage->Canvas->Rectangle(xx-FPointSize,yy-FPointSize,xx+FPointSize,yy+FPointSize);
               PaintPage->Canvas->LineTo(xx,yy);
             }
             break;
      }
   }
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawOrigin(void)
{
   TXYPoint TwoDP;
   TXYZPoint ThreeDP;

   ThreeDP.SetPoint(0,0,0);
   TwoDP = LocalToScreen(ConvertTo2D(&ThreeDP));
   PaintPage->Canvas->Pen->Color = clBlack;
   PaintPage->Canvas->MoveTo(TwoDP.X-4,TwoDP.Y);
   PaintPage->Canvas->LineTo(TwoDP.X+4,TwoDP.Y);
   PaintPage->Canvas->MoveTo(TwoDP.X,TwoDP.Y-4);
   PaintPage->Canvas->LineTo(TwoDP.X,TwoDP.Y+4);
}
//---------------------------------------------------------------------------
void TXYZPlot::DrawAllPlots(void)
{
   // Draw the plots
   int i,j;

   if(Visible)
   {
      if((FXMax != FXMin)&(FYMax != FYMin)&(FZMax != FZMin))
      {
         XYSurface[0].SetPoint(FXMin,FYMin,FZMin);
         XYSurface[1].SetPoint(FXMax,FYMin,FZMin);
         XYSurface[2].SetPoint(FXMin,FYMax,FZMin);
         XYSurface[3].SetPoint(FXMax,FYMax,FZMin);
         DistantPoint = 0;
         DistantPoint2 = 0;
         for(i=0;i<4;i++)
         {
            XYSurface[i] = LocalToGlobal(XYSurface[i]);
            if (XYSurface[DistantPoint].Y > XYSurface[i].Y)
                DistantPoint = i;
         }
         if (DistantPoint == 0) DistantPoint2 = 1;
         for(i=0;i<4;i++)
            if ((XYSurface[DistantPoint2].Y > XYSurface[i].Y)&&
                (i!=DistantPoint))
               DistantPoint2 = i;

         DrawBackAxis();
         if(FShowOrigin)
            DrawOrigin();
         for(j=0;j<XYZPlotList->Count;j++)
         {
            T3DPlotListMember *Ptr = (T3DPlotListMember *)XYZPlotList->Items[j];
            DrawOnePlot(Ptr);
         }// end while(CurrentPtr != NULL)
         DrawFrontAxis();
      }// end if((FXMax != FXMin)&(FYMax != FYMin))
   }
}
//---------------------------------------------------------------------------
inline void TXYZPlot::RedrawScreen(void)
{
     Canvas->CopyRect(ClientRect,PaintPage->Canvas,ClientRect);
}
//---------------------------------------------------------------------------
void TXYZPlot::Redraw(void)
{
   ClearPlot();
   CalculateAxisArray();
   ScaleScreen();
   DrawAllPlots();
   RedrawScreen();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::Paint(void)
{
// Event handler for repainting.
// Draws the Axis, plot labels, and plots.  Coordinates are drawn in the
// mouse move event handler
   PaintPage->Width = Width;
   PaintPage->Height = Height;
   Redraw();
   TPaintBox::Paint();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetBoxColor(TColor BC)
{
   FBoxColor = BC;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetPlaneColor(TColor PC)
{
   FPlaneColor = PC;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetXAxisColor(TColor AC)
{
   FXAxisColor = AC;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetYAxisColor(TColor AC)
{
   FYAxisColor = AC;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetZAxisColor(TColor AC)
{
   FZAxisColor = AC;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetShowLabels(bool SL)
{
   FShowXLabel = SL;
   FShowYLabel = SL;
   FShowZLabel = SL;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetShowXLabel(bool XL)
// set ShowXLabel property
{
   FShowXLabel = XL;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetShowYLabel(bool YL)
// set ShowYLabel property
{
   FShowYLabel = YL;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetShowZLabel(bool ZL)
// set ShowYLabel property
{
   FShowZLabel = ZL;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetPointSize(int PS)
{
   if (PS<1)
      FPointSize = 1;
   else if (PS>10)
      FPointSize = 10;
   else
      FPointSize = PS;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetVanishingPoint(double VP)
{
   if (VP > 0)
      FVanishingPoint = VP;
   else
      FVanishingPoint = 100;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetPerspectiveOn(bool PO)
{
   FPerspectiveOn = PO;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetFitToScreen(bool FS)
{
   FFitToScreen = FS;
   Origin->SetPoint((FXMax+FXMin)/2,(FYMax+FYMin)/2,(FZMax+FZMin)/2);
   if(FAutoRedraw)
     Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetAutoScale(bool AS)
{
   FAutoScale = AS;
   FindXYZMaxMin();
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetXMax(double value)
{
   FXMax = value;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetYMax(double value)
{
   FYMax = value;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetZMax(double value)
{
   FZMax = value;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetXMin(double value)
{
   FXMin = value;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetYMin(double value)
{
   FYMin = value;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetZMin(double value)
{
   FZMin = value;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void TXYZPlot::SetXYZMinMax(double xmin, double xmax, double ymin, double ymax,
                            double zmin, double zmax)
{
   FXMin = xmin;
   FXMax = xmax;
   FYMin = ymin;
   FYMax = ymax;
   FZMin = zmin;
   FZMax = zmax;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void TXYZPlot::SetAngles(double phi, double theta, double psi)
{
   FPhi = phi;
   FTheta = theta;
   FPsi = psi;
   if (abs(FPhi)>2*M_PI)
      FPhi = FPhi - 2*M_PI*floor(FPhi/(2*M_PI));
   if (abs(FTheta)>2*M_PI)
      FTheta = FTheta - 2*M_PI*floor(FTheta/(2*M_PI));
   if (abs(FPsi)>2*M_PI)
      FPsi = FPsi - 2*M_PI*floor(FPsi/(2*M_PI));
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetPhi(double angle)
{
   FPhi = angle;
   if (abs(FPhi)>2*M_PI)
      FPhi = FPhi - 2*M_PI*floor(FPhi/(2*M_PI));
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetTheta(double angle)
{
   FTheta = angle;
   if (abs(FTheta)>2*M_PI)
      FTheta = FTheta - 2*M_PI*floor(FTheta/(2*M_PI));
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetPsi(double angle)
{
   FPsi = angle;
   if (abs(FPsi)>2*M_PI)
      FPsi = FPsi - 2*M_PI*floor(FPsi/(2*M_PI));
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetMouseFunction(TMouseFunction MF)
{
   FMouseFunction = MF;
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetXLabelPrecision(int LP)
{
   if (LP>0)
      FXLabelPrecision = LP;
   else
      FXLabelPrecision = 0;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetYLabelPrecision(int LP)
{
   if (LP>0)
      FYLabelPrecision = LP;
   else
      FYLabelPrecision = 0;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetZLabelPrecision(int LP)
{
   if (LP>0)
      FZLabelPrecision = LP;
   else
      FZLabelPrecision = 0;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetXLabelFormat(AnsiString::TStringFloatFormat LF)
{
   FXLabelFormat = LF;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetYLabelFormat(AnsiString::TStringFloatFormat LF)
{
   FYLabelFormat = LF;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetZLabelFormat(AnsiString::TStringFloatFormat LF)
{
   FZLabelFormat = LF;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetAxisStyle(T3DAxisStyle AS)
{
   FAxisStyle = AS;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetShowOrigin(bool SO)
{
   FShowOrigin = SO;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetVisible(bool V)
{
   Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::MouseMove(Classes::TShiftState Shift, int X, int Y)
//  Event handler for Mouse Move.
{
   double DeltaX, DeltaY, DeltaFX, DeltaFY;

   TControl::MouseMove(Shift, X, Y);

   DeltaX = X - MouseX;
   DeltaY = Y - MouseY;
   MouseX = X;
   MouseY = Y;
   DeltaFX = -(FXMax-FXMin)*double(DeltaX)/ClientWidth;
   DeltaFY = (FYMax-FYMin)*double(DeltaY)/ClientHeight;
   if(RotatePhiPsi)
   {
      SetPhi(FPhi + DeltaFX/5);
      SetPsi(FPsi + DeltaFY/5);
      Redraw();
   }
   else if (RotatePhiTheta)
   {
      SetPhi(FPhi + DeltaFX/5);
      SetTheta(FTheta + DeltaFY/5);
      Redraw();
   }
   else if(DragXY)
   {
      FXMax -= DeltaFX;
      FXMin -= DeltaFX;
      FYMax += DeltaFY;
      FYMin += DeltaFY;
      Origin->SetPoint((FXMax+FXMin)/2,(FYMax+FYMin)/2,(FZMax+FZMin)/2);
      ScaleScreen();
      Redraw();
   }
   else if(DragXZ)
   {
      FXMax -= DeltaFX;
      FXMin -= DeltaFX;
      FZMax += DeltaFY;
      FZMin += DeltaFY;
      Origin->SetPoint((FXMax+FXMin)/2,(FYMax+FYMin)/2,(FZMax+FZMin)/2);
      ScaleScreen();
      Redraw();
   }
   else if(ZoomXZ)
   {
      FXMin -= DeltaFX;
      FXMax += DeltaFX;
      FZMin -= DeltaFY;
      FZMax += DeltaFY;
      Origin->SetPoint((FXMax+FXMin)/2,(FYMax+FYMin)/2,(FZMax+FZMin)/2);
      ScaleScreen();
      Redraw();
   }
   else if(ZoomXY)
   {
      FXMin -= DeltaFX;
      FXMax += DeltaFX;
      FYMin -= DeltaFY;
      FYMax += DeltaFY;
      Origin->SetPoint((FXMax+FXMin)/2,(FYMax+FYMin)/2,(FZMax+FZMin)/2);
      ScaleScreen();
      Redraw();
   }
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::MouseDown(TMouseButton Button,TShiftState Shift,
                        int X, int Y)
// Event handler for mouse down. If just the mouse button is pressed, DragPlot is
// set.  If both alt and mouse button, ZoomPlot is set.
{
   TShiftState LAltState, RAltState;

   TControl::MouseDown(Button, Shift, X, Y);
   LAltState << ssAlt << ssLeft;
   RAltState << ssAlt << ssRight;
   if(FMouseControl)
   {
      if (FMouseFunction == mfDrag)
      {
         if(Shift == LAltState)
            DragXY = true;
         else
            DragXZ = true;
      }
      else if (FMouseFunction == mfZoom)
      {
         if (Shift == LAltState)
            ZoomXY = true;
         else
            ZoomXZ = true;
      }
      else if (FMouseFunction == mfRotate)
      {
         if(Shift==LAltState)
            RotatePhiTheta=true;
         else
            RotatePhiPsi = true;
      }
   }
   MouseX = X;
   MouseY = Y;
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::MouseUp(TMouseButton Button,TShiftState Shift,
                         int X, int Y)
// Event handler for mouse up.  DragPlot and ZoomPlot are cleared.
{
   TControl::MouseUp(Button, Shift, X, Y);
   DragXY = false;
   DragXZ = false;
   ZoomXY = false;
   ZoomXZ = false;
   RotatePhiPsi = false;
   RotatePhiTheta = false;
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::DblClick(void)
// if autocales are set, double clicking autoscales the axis
{
   TControl::DblClick();
   if (MouseControl)
   {
      FindXYZMaxMin();
      Redraw();
   }
}
//---------------------------------------------------------------------------
bool TXYZPlot::FindPlot(T3DPlotListMember* &PlotPtr, int PNumber)
{
   bool PlotFound = false;
   int i;

   for(i=0;i<XYZPlotList->Count;i++)
   {
      PlotPtr = (T3DPlotListMember *)XYZPlotList->Items[i];
      if (PlotPtr->PlotIndex == PNumber)
      {
         PlotFound = true;
         break;
      }
   }

   return PlotFound;
}
//---------------------------------------------------------------------------
bool TXYZPlot::SetPlotLineColor(TColor PColor, int PNumber)
// sets the color of plot number PNumber. If the plot exists, a true is returned.
// If a plot with index PNumber is not found, a false is returned.
{
   bool PlotFound;
   T3DPlotListMember* PlotPtr;

   PlotFound = FindPlot(PlotPtr, PNumber);
   if (PlotFound)
      PlotPtr->LineColor = PColor;
   if(FAutoRedraw)
      Redraw();
   return PlotFound;
}
//---------------------------------------------------------------------------
bool TXYZPlot::SetPlotFillColor(TColor PColor, int PNumber)
{
   bool PlotFound;
   T3DPlotListMember* PlotPtr;

   PlotFound = FindPlot(PlotPtr, PNumber);
   if (PlotFound)
      PlotPtr->FillColor = PColor;
   if(FAutoRedraw)
      Redraw();
   return PlotFound;
}
//---------------------------------------------------------------------------
bool TXYZPlot::SetPlotStyle(T3DPlotStyle PStyle, int PNumber)
// sets the color of plot number PNumber. If the plot exists, a true is returned.
// If a plot with index PNumber is not found, a false is returned.
{
   bool PlotFound;
   T3DPlotListMember* PlotPtr;

   PlotFound = FindPlot(PlotPtr, PNumber);
   if (PlotFound)
      PlotPtr->PlotStyle = PStyle;
   if(FAutoRedraw)
      Redraw();
   return PlotFound;
}
//---------------------------------------------------------------------------
void __fastcall TXYZPlot::SetAutoRedraw(bool AR)
{
   FAutoRedraw = AR;
   if(FAutoRedraw)
      Redraw();
}
//---------------------------------------------------------------------------



